import pandas as pd


class Book:
    def __init__(self, name='', author='', publisher='', price='', publish_date='', genre='',
                 image_id='', rating='', book_type='', book_link='', source=''):
        self.__name = name
        self.__author = author
        self.__publisher = publisher
        self.__price = price
        self.__publish_date = publish_date
        self.__genre = genre
        self.__image_id = image_id
        self.__rating = rating
        self.__book_type = book_type
        self.__book_link = book_link
        self.__source = source

    @property
    def name(self):
        return self.__name

    @name.setter
    def name(self, name):
        self.__name = name

    @property
    def author(self):
        return self.__author

    @author.setter
    def author(self, author):
        self.__author = author

    @property
    def publisher(self):
        return self.__publisher

    @publisher.setter
    def publisher(self, publisher):
        self.__publisher = publisher

    @property
    def price(self):
        return self.__price

    @price.setter
    def price(self, price):
        self.__price = price

    @property
    def publish_date(self):
        return self.__publish_date

    @publish_date.setter
    def publish_date(self, publish_date):
        self.__publish_date = publish_date

    @property
    def genre(self):
        return self.__genre

    @genre.setter
    def genre(self, genre):
        self.__genre = genre

    @property
    def image_id(self):
        return self.__image_id

    @image_id.setter
    def image_id(self, image_id):
        self.__image_id = image_id

    @property
    def rating(self):
        return self.__rating

    @rating.setter
    def rating(self, rating):
        self.__rating = rating

    @property
    def book_type(self):
        return self.__book_type

    @book_type.setter
    def book_type(self, book_type):
        self.__book_type = book_type

    @property
    def book_link(self):
        return self.__book_link

    @book_link.setter
    def book_link(self, book_link):
        self.__book_link = book_link

    @property
    def source(self):
        return self.__source

    @source.setter
    def source(self, source):
        self.__source = source

    def __str__(self):
        return f"Name: {self.name}" \
               f"\nAuthor: {self.author}" \
               f"\nPublisher: {self.publisher}" \
               f"\nPrice: {self.price}" \
               f"\nRating: {self.rating}" \
               f"\nType: {self.book_type}" \
               f"\nLink: {self.book_link}" \
               f"\nSource: {self.source}"


class BookRelatedTools:
    def books_to_df(self, books):
        books_list = []
        for book in books:
            book_dict = {
                        'Name': book.name,
                        'Author': book.author,
                        'Publisher': book.publisher,
                        'Price': book.price,
                        'Publish Date': book.publish_date,
                        'Genre': book.genre,
                        'Image ID': book.image_id,
                        'Rating': book.rating,
                        'Type': book.book_type,
                        'Link': book.book_link,
                        'Source': book.source
            }
            books_list += [book_dict]
        return pd.DataFrame(books_list)

    def df_to_book(self, df):
        return Book(name=df['Name'],
                    author=df['Author'],
                    publisher=df['Publisher'],
                    price=df['Price'],
                    rating=df['Rating'],
                    book_type=df['Type'],
                    book_link=df['Link'],
                    source=df['Source'])
